package com.brilliance.isc.mda.dao;

import com.brilliance.isc.bo.Dia;
import com.brilliance.isc.bo.DiaManage;
import com.brilliance.isc.vo.lg.ComselVo;
import com.brilliance.isc.vo.lg.QueryConditionInfoVo;
import com.brilliance.isc.vo.manager.DiaManageVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;
import java.util.Map;

@Mapper
public interface DiaMapper {

    int insert2(DiaManage record);

    int insert(Dia record);

    int insertSelective(Dia record);

    int updateByPrimaryKeySelective(Dia record);

    int updateByPrimaryKey(Dia record);

    int deleteByPrimaryKey(Dia record);

    int deleteByIds(Collection<Object> collection);

    Dia selectByPrimaryKey(Dia record);

    int dyncDelete(Map<String,Object> dyncMap);

    List<Dia> dyncRead(Map<String,Object> dyncMap);

    List<String> getInrByObj(@Param("objtyp") String objtyp, @Param("objinr") String objinr);

    List<Dia> getDiaByObjtypAndObjinr(@Param("objtyp") String objtyp, @Param("objinr") String objinr);

    int deleteDiaByCretypAndCreinr(@Param("cretyp") String cretyp, @Param("creinr") String creinr, @Param("frm") String frm);

    Dia getDiaByCretypAndCreinr(@Param("cretyp") String cretyp, @Param("creinr") String creinr, @Param("frm") String frm);

    Dia getDiaByObjtypAndObjinrAndFrm(@Param("objtyp") String objtyp, @Param("objinr") String objinr, @Param("frm") String frm);

    List<Dia> getDiaByObjtypAndObjinrAndFrmOrderByDat(@Param("objtyp") String objtyp, @Param("objinr") String objinr, @Param("frm") String frm);

    Dia getDiaByObjtypAndObjinrAndFrmAndDonflg(@Param("objtyp") String objtyp, @Param("objinr") String objinr, @Param("frm") String frm, @Param("donflg") String donflg);

    List<Dia> getDiaListGroupByObjtypAndObjinr(@Param("objtyp") String objtyp, @Param("objinr") String objinr);

    List<ComselVo> getComselList(QueryConditionInfoVo conditionInfoVo);
    /**
     * 通过ID查询单条数据
     *
     * @param inr 主键
     * @return 实例对象
     */
    DiaManage queryById(@Param("inr") String inr);

    /**
     * 通过ID查询单条数据
     *
     * @param dia
     * @param tableName 查询目标表
     * @return 实例对象
     */
    DiaManageVo queryOtherInfo(@Param("dia") DiaManage dia, @Param("tableName") String tableName);

    DiaManageVo queryOtherInfoByInr(@Param("dia") DiaManage dia, @Param("tableName") String tableName);

    /**
     * 查询指定行数据
     *
     * @param dia 查询条件
     * @return 对象列表
     */
    List<DiaManage> queryAllByLimit(@Param("dia")DiaManageVo dia,@Param("list") List<String> list);

    /**
     * 统计首页diary数量查询
     *
     * @param dia 查询条件
     * @return 总行数
     */
    int getCountDiaHome(@Param("dia")DiaManageVo dia,@Param("list") List<String> list);

    /**
     * 统计总行数
     *
     * @param dia 查询条件
     * @return 总行数
     */
    long count(@Param("dia")Dia dia,@Param("list") List<String> list);

    /**
     * 新增数据
     *
     * @param dia 实例对象
     * @return 影响行数
     */
//    int insert(Dia dia);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<Dia> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<Dia> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<Dia> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<Dia> entities);

    /**
     * 修改数据
     *
     * @param dia 实例对象
     * @return 影响行数
     */
    int update(DiaManage dia);

    /**
     * 通过主键删除数据
     *
     * @param inr 主键
     * @return 影响行数
     */
    int deleteById(@Param("inr") String inr);

    /**
     * 根据vo查询数量
     *
     * @param dia 入参
     * @return int 返回结果
     */
    int queryCountByVo(@Param("dia") DiaManage dia,@Param("list") List<String> list);

    /**
     * 查询objinr字段
     *
     * @param dia 入参
     * @return String 返回结果
     */
    String queryXXD(@Param("dia") DiaManage dia);

    int updateDonflg(Dia record);

    List<Dia> selectByCondition(Dia dia);

}